package normalSorter;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Collections;
import java.util.Comparator;
import java.util.Vector;

import javax.swing.AbstractListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;

public class NormalSorter extends JFrame {

    int width=500;
    int height=500;
    JList namesLst;
    JButton sortBtn1;
    JButton sortBtn2;
    
    public NormalSorter() {
	
	setPreferredSize(new Dimension(width, height));
	center();
	setLayout(new BorderLayout());
	addComponents();
	pack();
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	setVisible(true);
    }
    
    void addComponents(){
	Vector<Person> persons=new Vector<Person>();
	persons.add(new Person("Katarina", 1989));
	persons.add(new Person("Marko", 1988));
	persons.add(new Person("Ana", 1990));
	persons.add(new Person("Ognjenka", 1986));
	PersonModel model=new PersonModel(persons);
	namesLst=new JList(model);
	namesLst.addMouseListener(new MouseAdapter() {
	@Override
	public void mouseClicked(MouseEvent e) {
	    String response=JOptionPane.showInputDialog("Type name and year of birth:");
	    String[] tokens=response.split(" ");
	    String name=tokens[0];
	    Integer birthYear=Integer.parseInt(tokens[1]);
	    PersonModel model=(PersonModel)namesLst.getModel();
	    model.addPerson(name, birthYear);
	}
	
	});
	add(namesLst, BorderLayout.CENTER);
	sortBtn1=new JButton("Sort by name");
	sortBtn1.addActionListener(new ActionListener() {
	    
	    @Override
	    public void actionPerformed(ActionEvent e) {
		PersonModel model=(PersonModel)namesLst.getModel();
		model.sortByName();
	    }
	});
	add(sortBtn1, BorderLayout.NORTH);
	
	sortBtn2=new JButton("Sort by birth year");
	sortBtn2.addActionListener(new ActionListener() {
	    
	    @Override
	    public void actionPerformed(ActionEvent e) {
	
		namesLst.repaint();
		
	    }
	});
	add(sortBtn2, BorderLayout.SOUTH);
    }
    /**s
     * @param args
     */
    public static void main(String[] args) {
	NormalSorter gui=new NormalSorter();
    }
    
    void center(){
	Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-width)/2, (d.height-height)/2);
    }

}

class Person implements Comparable<Person>{
    
    String name;
    int birthYear;
    
    public Person(String name, int birthYear) {
	this.name=name;
	this.birthYear=birthYear;
    }
    
    @Override
    public int compareTo(Person o) {
        return this.name.compareTo(o.name);
    }
    
    @Override
    public String toString() {
        return name+" "+birthYear;
    }
}

class PersonModel extends AbstractListModel{
    Vector<Person> persons=new Vector<Person>();
    public PersonModel(Vector<Person> p) {
	this.persons=p;
    }
    
    @Override
    public Object getElementAt(int index) {
        return persons.get(index);
    }
     
    @Override
    public int getSize() {
        return persons.size();
    }
    
    public void sortByBirthYear(){
	
	Collections.sort(persons, new Comparator<Person>() {
	    @Override
	    public int compare(Person o1, Person o2) {
	        return o1.birthYear-o2.birthYear;
	    }
	});
	
    }
    
    public void sortByName(){
	Collections.sort(persons);
	fireContentsChanged(this, 0, getSize()-1);
    }
    
    public void addPerson(String name, Integer birthYear){
	Person p=new Person(name, birthYear);
	persons.add(p);
	fireIntervalAdded(this, getSize()-1, getSize());
    }
}
